
.386p
code32 segment para public use32
        assume cs:code32, ds:code32


include defines.inc
include sys.inc
include hexit.inc
include bss.inc


; out:  ax: 0 if ok
;       bx: -1 = 2 buttons
_initmouse:
        mov     v86r_ax,0
        mov     al,33h
        int     33h
        mov     ax,v86r_ax
        mov     bx,v86r_bx
        ret


; out:  cx = horizontal mickeys moved
;       dx = vertical mickeys moved
_readmouse:
        mov     v86r_ax,0bh
        mov     al,33h
        int     33h
        mov     cx,v86r_cx
        mov     dx,v86r_dx
        ret


; Resets motion-counters
_resetmouse:
	cmp	mouseavailable,1
	jne	_ret
	push	eax
	mov	v86r_ax,0bh
	mov	al,33h
	int	33h
	pop	eax
	ret


; out:  BX bit 0 = left button pressed
;       BX bit 1 = right button pressed
;       BX bit 2 = middle button pressed
_getmousebuttons:
	mov	v86r_ax,03h			; test buttons
	mov	al,33h
	int	33h
        mov     bx,v86r_bx
        ret


; out:  ch = start line
;       cl = end line
;       dh = row
;       dl = column
_getcursorpos:
        push    eax
        mov     v86r_ah,3
        mov     v86r_bh,0
        mov     al,10h
        int     33h
        mov     cx,v86r_cx
        mov     dx,v86r_dx
        pop     eax
        ret


; in:   dh = row (0 = top)
;       dl = column (0 = leftmost)
_setcursorpos:
        push    eax
        mov     v86r_dx,dx
	mov	v86r_ah,02h
	mov	v86r_bh,0
	mov	al,10h
	int	33h
        pop     eax
        ret


;
_setinsertcursor:
	pushad
	mov	v86r_ah,01
	movzx	eax,activevideomode
	dec	eax
	mov	ch,fontsize[eax]
	sub	ch,curssizei
	jnc	oki1
	xor	ch,ch
oki1:
	or	ch,40h
	mov	cl,fontsize[eax]
	mov	v86r_cx,cx
	mov	al,10h
	int	33h
	popad
	ret


;
_setoverwritecursor:
	pushad
	mov	v86r_ah,01
	movzx	eax,activevideomode
	dec	eax
	mov	ch,fontsize[eax]
	sub	ch,curssizeo
	jnc	oki2
	xor	ch,ch
oki2:
	or	ch,40h
	mov	cl,fontsize[eax]
	dec	cl
	mov	v86r_cx,cx
	mov	al,10h
	int	33h
	popad
	ret


;
_setnummenufieldcursor:
	pushad
	mov	v86r_ah,01
	movzx	eax,activevideomode
	dec	eax
	mov	ch,fontsize[eax]
	sub	ch,misc_nummenufieldcurssize
	jnc	__setnummenufieldcursor_nc
	xor	ch,ch
__setnummenufieldcursor_nc:
	or	ch,40h
	mov	cl,fontsize[eax]
	mov	v86r_cx,cx
	mov	al,10h
	int	33h
	popad
	ret


;
; Hides the cursor
_hidecursor:
	pushad
	mov	v86r_ah,01		; hide cursor
	mov	v86r_ch,00100000b
	mov	al,10h
	int	33h
	popad
	ret


;----------------------------------------------------------------------------
_disablecursoremu:
        mov     v86r_ax,1201h
        mov     v86r_bl,34h
        mov     al,10h
        int     33h
        ret


_enablecursoremu:
	mov	v86r_ax,1200h
	mov	v86r_bl,34h
	mov	al,10h
	int	33h
        ret


; in:   ah bits 0..4 = start line
;       ah bits 5..6 = blink style (0 = normal, 1 = invis, 2 = slow, 3 = fast)
;       al bits 0..4 = end line
_setcursorsize:
	mov	v86r_ah,1
	mov	v86r_cx,ax
	mov	al,10h
	int	33h
        ret


;
; Checks if there is a key available (in keystack or manually pressed)
; Out:
;	ZF set if no key available
;	ZF clear if key available (use _getkey to fetch it)
_checkkey:
	push	eax
	cmp	keysinbuffer,0
	jne	__checkkey_clz
	mov	v86r_ah,11h
	mov	al,16h
	int	33h
	jmp	__checkkey_done
__checkkey_clz:
	xor	al,al
	add	al,1
__checkkey_done:
	pop	eax
	ret


;
; Gets the last key (or waits for a keypress if there is none).
; Out:
;	AL	= character
;	AH	= scancode
;	BL      = shiftkeys (shift, ctrl, alt. see int 16,2)
;	CF	= 1 if a key was released, 0 if pressed
_getkey:
	mov	v86r_ah,11h
	mov	al,16h
	int	33h
	jz	__getkey_popkey

__getkey_getch:
	mov	v86r_ah,10h
	mov	al,16h
	int	33h
	push	v86r_ax
	mov	v86r_ah,02h
	mov	al,16h
	int	33h
	mov	al,v86r_al
	and	al,0fh			; mask out keys
	test	al,3			; or leftshift, rightshift
	jz	__fixshiftkeys
	or	al,3
__fixshiftkeys:
        mov     bl,al
	shl	eax,16
	pop	ax
	call	_pushkey
__getkey_popkey:
        cmp     keysinbuffer,0
        je      __getkey_getch
        call    _popkey
        clc
        ret


;
; Waits for mousebutton to be released
; _waitbuttonrelease(buttoncode);
; buttoncode:	1 = left button
;		2 = right button
;		4 = middle button
;
_waitbuttonrelease:
	push	eax
wbrlop:
	mov	v86r_ax,03h
	mov	al,33h
	int	33h
	mov	eax,[esp+4*2]
	test	v86r_bx,ax
	jnz	wbrlop
	pop	eax
	ret	4


;
; Waits X microseconds
; Syntax: _delay(microseconds);
_delay:
	push	eax
	mov	eax,[esp+4*2]
	mov	v86r_dx,ax
	shr	eax,16
	mov	v86r_cx,ax
	mov	v86r_ah,86h
	mov	al,15h
	int	33h
	pop	eax
	ret	4


;
_restorevideo:
	pushad
	cmp	videosaved,0		; restore if saved
	je	_continuerestore
_restoreerror:
	mov	numberofrows,25 	; not saved => set 80x25
	call	_setvideo
	popad
	ret

_continuerestore:
	mov	v86r_ah,12h		; restore scanlines
	mov	ebp,old_video_ptr
	add	ebp,_code32a

	cmp	byte ptr gs:[ebp+5h],80
	jne	_rvnot80columns
	movzx	eax,byte ptr gs:[ebp+22h]
	cmp	eax,numberofrows
	jne	_rvnot80columns
	call	_setvideo
	jmp	_popad&ret
_rvnot80columns:

	mov	al,gs:[ebp+2ah]
	mov	v86r_al,al
	mov	v86r_bl,30h
	mov	al,10h
	int	33h
	cmp	v86r_al,12h		; check if OK
	jne	_restoreerror
	mov	v86r_ah,0		; restore videomode
	mov	al,gs:[ebp+4h]
	mov	v86r_al,al
	mov	al,10h
	int	33h
	mov	v86r_ax,1110h		; restore fontheight
	mov	bx,gs:[ebp+23h]
	cmp	bl,14
	jne	_not8x14
	add	v86r_al,1
	jmp	_setheight
_not8x14:
	cmp	bl,8
	jne	_not8x8
	add	v86r_al,2
	jmp	_setheight
_not8x8:
	add	v86r_al,4
_setheight:
	mov	v86r_bx,0
	mov	al,10h
	int	33h
	popad
	ret


;
_savevideo:
	pushad
	mov	v86r_ah,1bh		; save videostate
	mov	v86r_bx,0
	mov	esi,old_video_ptr
	add	esi,_code32a
	mov	ax,si
	and	ax,0fh
	mov	v86r_di,ax
	shr	esi,4
	mov	v86r_es,si
	mov	al,10h
	int	33h
	cmp	v86r_al,1bh
	jne	_notsaved
	mov	videosaved,0		; clear if saved

	cmp	autodetectvideo,1
	je	detectit
	mov	numberofrows,25
	mov	activevideomode,1
	cmp	autodetectvideo,2
	je	_popad&ret
	mov	numberofrows,28
	mov	activevideomode,2
	cmp	autodetectvideo,3
	je	_popad&ret
	mov	numberofrows,43
	mov	activevideomode,3
	cmp	autodetectvideo,4
	je	_popad&ret
	mov	numberofrows,50
	mov	activevideomode,4
	cmp	autodetectvideo,5
	je	_popad&ret
	mov	numberofrows,60
	mov	activevideomode,5
	jmp	_popad&ret

detectit:
	mov	numberofrows,25
	mov	al,gs:[484h]
	cmp	al,59
	jne	svnot60
	mov	numberofrows,60
	mov	activevideomode,5
	jmp	_popad&ret
svnot60:
	cmp	al,49
	jne	svnot50
	mov	numberofrows,50
	mov	activevideomode,4
	jmp	_popad&ret
svnot50:
	cmp	al,42
	jne	svnot43
	mov	numberofrows,43
	mov	activevideomode,3
	jmp	_popad&ret
svnot43:
	cmp	al,27
	jne	svnot28
	mov	numberofrows,28
	mov	activevideomode,2
	jmp	_popad&ret
svnot28:
	jmp	_popad&ret

	mov	esi,old_video_ptr	; get active number of rows, to
	add	esi,_code32a		; be able to start up correctly
	mov	al,gs:[esi+4h]		; check if mode 3
	cmp	al,3
	jne	_popad&ret		; not mode 3
	mov	al,gs:[esi+2ah] 	;
	cmp	al,2			; check if 400 sl's
	jne	_43lines?		; not 400 scanlines
	mov	bx,gs:[esi+23h] 	; check fontheight
	cmp	bl,8			; is it 8 scanlines?
	jne	_28lines?		;
	mov	numberofrows,50 	;
	mov	activevideomode,4
	jmp	_popad&ret
_28lines?:
	cmp	bl,14
	jne	_popad&ret
	mov	numberofrows,28
	mov	activevideomode,2
	jmp	_popad&ret
_43lines?:
	cmp	al,1
	jne	_popad&ret
	mov	bx,gs:[esi+23h] 	; check fontheight
	cmp	bl,8			; is it 8 scanlines?
	jne	_popad&ret
	mov	numberofrows,43
	mov	activevideomode,3
	jmp	_popad&ret
_notsaved:
	mov	videosaved,-1		; set if video not saved
	popad
	ret


;
_setvideo:
	pushad
	movzx	eax,byte ptr gs:[484h]
	inc	eax
	cmp	eax,numberofrows
	jne	_svsetmode
	mov	al,gs:[44ah]
	cmp	al,80
	jne	_svsetmode
	mov	edi,textscreenstart
	mov	ecx,numberofrows
	lea	ecx,[ecx*4+ecx]
	shl	ecx,3
	mov	eax,07200720h
	rep	stosd
	xor	dx,dx
	call	_setcursorpos

	mov	v86r_ax,1003h		; enable intensity (bkgcolor > 7)
	mov	v86r_bx,0
	mov	al,10h
	int	33h

	call	_setinsertcursor

	jmp	_popad&ret

_svsetmode:
	cmp	numberofrows,60
	je	setv60
	mov	v86r_ax,1202h
	cmp	numberofrows,43
	jne	_not43_1
	mov	v86r_ax,1201h
_not43_1:
	mov	v86r_bl,30h
	mov	al,10h
	int	33h
	mov	v86r_ax,3
	mov	al,10h
	int	33h
	mov	v86r_ax,1112h		; set 80x43 or 80x50
	cmp	numberofrows,50
	je	_initfont
	cmp	numberofrows,43
	je	_initfont
	mov	v86r_ax,1114h		; set 80x25
	cmp	numberofrows,28
	jne	_initfont
	mov	v86r_ax,1111h		; set 80x28
_initfont:
	mov	v86r_bx,0
	mov	al,10h
	int	33h

	mov	v86r_ax,1003h		; enable intensity (bkgcolor > 7)
	mov	v86r_bx,0
	mov	al,10h
	int	33h

	popad
	ret

setv60:
	mov	v86r_ax,1202h
	mov	v86r_bl,30h
	mov	al,10h
	int	33h
	mov	v86r_ax,3
	mov	al,10h
	int	33h
	mov	v86r_ax,1112h
	mov	v86r_bl,0
	mov	al,10h
	int	33h

	mov	dx,3cch
	in	al,dx
	mov	dl,0c2h
	or	al,3*64   ; Set scanline type 3 - 480
	out	dx,al

	mov	dx,3d4h
	mov	al,11h
	out	dx,al
	inc	dx
	and	al,not (15+128)
	or	al,12
	mov	bl,al
	out	dx,al	 ; Disable protection

	dec	dx
	mov	esi,offset V480data
	mov	ecx,V480size
@OutIt:
	lodsw
	out	dx,ax	 ; Set vertical 480 parameters
	loop	@OutIt

	mov	al,11h
	out	dx,al
	inc	dx
	mov	al,bl
	out	dx,al	 ; Enable protection

	mov	byte ptr gs:[0484h],59	; Set number of lines for BIOS
	popad
	ret



;		   Lines   Scanl   Fontheight
;  modes   db	   '12',     0,      4
;	   db	   '14',     0,      1
;	   db	   '21',     1,      4
;	   db	   '25',     2,      4
;	   db	   '28',     2,      1
;	   db	   '43',     1,      2
;	   db	   '50',     2,      2
;  Scanlines:  0 = 200
;	       1 = 350
;	       2 = 400
;  FontHeight  2 = 8
;	       1 = 14
;	       4 = 16


;
; Expands a filename with possible wildcards to the right number of files.
; In:	EDX -> Filename
; Out:	ECX = Number of files found and processed
; Note: If wildcards give more files than one then the space 128 bytes
;	after Filename is used.
_expandwildcards:
	pushad
	mov	esi,edx
	lea	edi,temp128bytes
	xor	eax,eax
__ewc_lop:
	mov	bl,al
	lodsb
	stosb
	cmp	al,'.'
	jne	__ewc_dot
	mov	ah,1
__ewc_dot:
	cmp	al,'\'
	jne	__ewc_bslash
	xor	ah,ah
__ewc_bslash:
	or	al,al
	jnz	__ewc_lop

	or	ah,ah
	jnz	__ewc_dotfound
	cmp	bl,'*'
	jne	__ewc_dotfound
	mov	dword ptr [esi-1],0002a2eh	; '.*',0
	mov	dword ptr [edi-1],0002a2eh	; '.*',0
__ewc_dotfound:

	mov	tempdw,0
	mov	v86r_ah,4eh
	mov	v86r_cx,027h		; all entrys except volumes&dirs
	mov	eax,edx
	add	eax,_code32a
	mov	v86r_dx,ax
	and	v86r_dx,0fh
	shr	eax,4
	mov	v86r_ds,ax
	mov	al,21h
	int	33h
	jc	endofexpwildc
processmorefiles:
	mov	eax,numberoffiles
	add	eax,tempdw
	cmp	eax,MAXFILES
	jae	endofexpwildc
	inc	tempdw
	mov	edi,edx
	xor	al,al
	mov	ecx,-1
	repne	scasb
notdiryet:
	cmp	edi,edx
	jbe	nodiratall
	dec	edi
	cmp	byte ptr [edi-1],'\'
	je	nodiratall
	cmp	byte ptr [edi-1],':'
	jne	notdiryet
nodiratall:
	mov	esi,offset dta+1eh
copyname:
	lodsb
	stosb
	or	al,al
	jnz	copyname

	mov	eax,numberoffiles
	add	eax,tempdw
	cmp	eax,MAXFILES
	jae	endofexpwildc

	add	edx,128
	mov	edi,edx 		; temp128bytes is used to make sure
	mov	esi,offset temp128bytes ; that all the expanded files get
	mov	ecx,128 		; the same path
	rep	movsb

	mov	v86r_ah,4fh
	mov	al,21h
	int	33h
	jnc	processmorefiles
endofexpwildc:
	popad
	mov	ecx,tempdw
	clc
	ret


;
; Make full path name
_makefullpathname:
	pushad
	mov	mfpndrive,0
	movzx	eax,activewindow
	movzx	eax,activefile[eax]
	mov	edi,offset temp128bytes
	mov	esi,offset filename
	add	esi,_code32a
	add	edi,_code32a
	shl	eax,7
	add	esi,eax
	mov	ebp,esi
	sub	ebp,_code32a
	push	esi
	cmp	byte ptr gs:[esi+1],':'
	jne	mfpnnospec
	cmp	byte ptr gs:[esi+2],'\'
	je	mfpnnospec
	mov	al,gs:[esi]
	mov	gs:[edi],al
	and	al,0dfh 		    ; _tolower
	sub	al,'A'-1
	mov	mfpndrive,al
	pop	edi
	mov	esi,offset temp128bytes+2   ; we would have added 2 further down

	mov	byte ptr [esi-1],':' ;;;;;;;;

	sub	edi,_code32a
	add	edi,2			    ; remove first 2 chars ( "X:" )
	mov	byte ptr [esi],'\'
	cmp	byte ptr [edi],'.'
	jne	mfpnerr 		    ; misfitting name as usual... ;)
	cmp	byte ptr [edi+1],'.'
	je	mfpnerr
	inc	edi
	cmp	byte ptr [edi],'\'
	jne	mfpnerr
	inc	edi
	jmp	mfpnerr 		    ; misfitting name as usual... ;)
mfpnnospec:
	mov	v86r_si,si
	and	v86r_si,0fh
	mov	v86r_di,di
	and	v86r_di,0fh
	shr	esi,4
	shr	edi,4
	mov	v86r_ds,si
	mov	v86r_es,di
	mov	v86r_ah,60h
	mov	al,21h
	int	33h
	pop	edi
	mov	esi,offset temp128bytes

	sub	edi,_code32a
	mov	byte ptr [esi+2],'\'
	add	esi,2
	cmp	byte ptr [edi],'\'
	je	mfpnprelop
	cmp	byte ptr [edi+1],':'
	jne	mfpnnodrivespecified
	sub	esi,2
	jmp	mfpnprelop
mfpnnodrivespecified:
	mov	v86r_ah,01fh
	mov	al,21h
	int	33h
	cmp	v86r_al,0
	jne	mfpnerr
	movzx	eax,v86r_ds
	shl	eax,4
	movzx	ebx,v86r_bx
	add	eax,ebx
	mov	al,gs:[eax]
	add	al,'A'
	mov	[esi-2],al
	mov	byte ptr [esi-1],':'
mfpnerr:

	inc	esi
	push	esi
	add	esi,_code32a
	mov	v86r_si,si
	and	v86r_si,0fh
	shr	esi,4
	mov	v86r_ds,si
	mov	v86r_ah,47h
	mov	al,mfpndrive
	mov	v86r_dl,al
	mov	al,21h
	int	33h
	pop	esi
	xchg	esi,edi
	xor	al,al
	mov	ecx,-1
	repne	scasb
	dec	edi
	cmp	byte ptr [edi-1],'\'
	je	mfpnlop
	inc	edi
	mov	byte ptr [edi-1],'\'
	jmp	mfpnlop
mfpnprelop:
	xchg	esi,edi
mfpnlop:
	lodsb
	cmp	al,'.'
	jne	mfpnnotdot
	cmp	byte ptr [esi],'.'
	je	mfpndot
	cmp	byte ptr [esi-2],'\'
	je	mfpndot
mfpnnotdot:
	stosb
	test	al,0ffh
	jz	mfpndone
	jmp	mfpnlop
mfpndot:
	lodsb
	cmp	al,'\'
	je	mfpnlop
	cmp	al,'.'
	jne	mfpndot
	cmp	byte ptr [edi-2],':'
	je	mfpnerrpath
	sub	edi,2
	mov	al,'\'
	mov	ecx,-1
	std
	repne	scasb
	cld
	add	edi,2
	jmp	mfpndot
mfpndone:
	mov	esi,offset temp128bytes
	mov	edi,ebp
mfpnlop1:
	movsb
	cmp	byte ptr [esi-1],0
	jne	mfpnlop1
	mov	edi,ebp

	cmp	word ptr [edi],'\\'
	jne	_convtoupper23
	cmp	byte ptr [edi+2],'\'
	jne	_convtoupper23

mfpncdfix:
	mov	al,[edi+2]
	stosb
	or	al,al
	jnz	mfpncdfix
	mov	edi,ebp

_convtoupper23:
	mov	al,[edi]
	call	_toupper
	stosb
	or	al,al
	jnz	_convtoupper23
	popad
	ret

mfpnerrpath:
	popad
	ret


;
_int24h:
	xor	al,al
	sti
	iret


;-----------------------------------------------------------------------------
_restore24hint:
	mov	v86r_ax,2524h		; restore old int24h address
	mov	ax,_segi24h
	mov	v86r_ds,ax
	mov	ax,_offi24h
	mov	v86r_dx,ax
	mov	al,21h
	int	33h
        ret


;-----------------------------------------------------------------------------
_set24hint:
	mov	v86r_ax,3524h			; get old int24h address
	mov	al,21h
	int	33h
	mov	ax,v86r_es
	mov	_segi24h,ax
	mov	ax,v86r_bx
	mov	_offi24h,ax

	mov	edx,offset _int24h
	add	edx,_code32a
	mov	ax,dx
	and	ax,0fh
	shr	edx,4
	mov	v86r_ds,dx
	mov	v86r_dx,ax
	mov	v86r_ax,2524h
	mov	al,21h
	int	33h
        ret


;-----------------------------------------------------------------------------
_setdta:
	mov	v86r_ah,1ah			; set DiskTransferArea address
	mov	edx,offset dta
	add	edx,_code32a
	mov	v86r_dx,dx
	and	v86r_dx,0fh
	shr	edx,4
	mov	v86r_ds,dx
	mov	al,21h
	int	33h
        ret


;-----------------------------------------------------------------------------
; out:  al = shift status bits
_getshiftkeys:
	mov	v86r_ah,02h
	mov	al,16h
	int	33h
        mov     al,v86r_al
        ret


;-----------------------------------------------------------------------------
; Out:	AX = 0 if NOT under DPMI
_checkDPMI:
	cmp	dword ptr gs:[2fh*4],0
	je	_ret
	mov	v86r_ax,1687h	; Check if under DPMI
	mov	al,2fh
	int	33h
	mov	indpmi,ax
	ret


;-----------------------------------------------------------------------------
; This function releases timeslices if you're running under DPMI
_slice:
	cmp	indpmi,0
	je	_ret
	mov	v86r_ax,1680h	     ; DPMI release timeslice
	mov	al,2fh
	int	33h
	ret


;-----------------------------------------------------------------------------
_putch:
	mov	v86r_al,al
	mov	al,29h
	int	33h
        ret


;-----------------------------------------------------------------------------
; In:	EDX -> '$'-terminated string
;		also handles ASCIZ strings now...
_puts:
	pushad
	mov	esi,edx
.loop:
	lodsb
	cmp	al,'$'
	je	.end
	or	al,al
	jz	.end
	mov	v86r_ah,2
	mov	v86r_dl,al
	mov	al,21h
	int	33h
	jmp	.loop
;	add	edx,_code32a
;	shld	eax,edx,28
;	and	edx,0fh
;	mov	v86r_ds,ax
;	mov	v86r_dx,dx
;	mov	v86r_ah,9
;	mov	al,21h
;	int	33h
.end:
	popad
	ret


;-----------------------------------------------------------------------------
_getexefullpath:
        pushad
	mov	esi,_pspa
	movzx	edi,word ptr gs:[esi+2ch]
	shl	edi,4
	xor	al,al
	mov	ecx,65535
	cld
.forts1:
	inc	edi
	cmp	gs:[edi-1],al
	jne	.forts1
	inc	edi
	cmp	gs:[edi-1],al
	jnz	.forts1
	add	edi,2			; edi -> ASCIZ programname incl. path
        mov     esi,edi
        lea     edi,exefullpath
.efplop:
        mov     al,gs:[esi]
        inc     esi
        stosb
        or      al,al
        jnz     .efplop
        popad
        lea     esi,exefullpath
        ret


;-----------------------------------------------------------------------------
_allocmainmem:
	mov	eax,_himemtop		; allocate as much hi mem as
	sub	eax,_himembase		; possible...
	sub	eax,5			; Ahum... for security reasons. Page
	jnc	__init_notzerohimem	; faults occured otherwise...
	xor	eax,eax
__init_notzerohimem:
	mov	freehimemory,eax
	add	eax,_himembase
	xchg	eax,_himembase
        ret


;-----------------------------------------------------------------------------
; in:	EAX = additional size needed
; out:	CF  = 1 on error
_reallocmainmem:
	stc
	ret


;-----------------------------------------------------------------------------
_getmainmemtop:
        mov     eax,_himemtop
        ret


;-----------------------------------------------------------------------------
; out:	EAX = max # of free bytes available for allocation
_getmaxfreemem:
	mov	eax,freehimemory
	ret


;-----------------------------------------------------------------------------
; esi -> cmdline
; ecx == length of cmdline
_getcmdline:
        pushad
        mov     esi,_pspa
        add     esi,81h
        lea     edi,cmdline
        movzx   ecx,byte ptr gs:[esi-1]
        mov     [esp+6*4],ecx   ; pushed ecx
        mov     [esp+1*4],edi   ; pushed esi
	jecxz	@@done
@@lop:
        mov     al,gs:[esi]
        inc     esi
        stosb
        loop    @@lop
@@done:
        xor     al,al
        stosb
        popad
        ret

cmdline db      256 dup(?)


;-----------------------------------------------------------------------------
_exithexit:
        call    _restore24hint
        call    _enablecursoremu
	mov	ax,initcursorsize
        call    _setcursorsize
        jmp     _exit


;-----------------------------------------------------------------------------
; out:  CF = 1 on error
_sysinit:
        pushad
        call    _getcursorpos
	mov	initcursorsize,cx
        call    _disablecursoremu
        call    _set24hint
        call    _setdta

        mov     eax,0b8000h
	sub	eax,_code32a			; store pointer to textscreen
	mov	textscreenstart,eax
        popad
        clc
        ret


;-----------------------------------------------------------------------------
_runhelper:
	ret 

;-----------------------------------------------------------------------------
_updaterows:
        ret


;-----------------------------------------------------------------------------
_popad&ret:
        popad
        ret


;-----------------------------------------------------------------------------
V480data	dw	0B06h,3E07h,0EA10h,0DF12h,0E715h,0416h
V480size = ($-V480data) shr 1

fontsize	db	16
		db	14
		db	8
		db	8
		db	8


code32  ends
end

